#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <dlfcn.h>
#include <unistd.h> 
#include <sys/wait.h>


#ifdef __alpha__
#define LIBCPATH "/lib/libc.so.6.1"
#else
#define LIBCPATH "/lib/libc.so.6"
#endif

void load_library_symbols(void);

extern pid_t (*next_vfork)(void);

pid_t tmp_vfork (void){
    load_library_symbols();
    return  next_vfork ();
}

pid_t (*next_vfork)(void)=tmp_vfork;

void load_library_symbols(void){
    static int done = 0;
    char* msg;
  
    if(!done){
	(void *)(next_vfork)=dlsym(dlopen(LIBCPATH,RTLD_LAZY), "vfork");
	if ( (msg = dlerror()) != NULL ){
	    fprintf (stderr, "vforkwrap: dlsym(%s): %s\n", "vfork", msg);
	}
    }
    done = 1;
}

pid_t vfork(void){
    pid_t p = fork();
    if (p > 0) {
	/* Parent, sort of immitates vfork() */
	wait4(p, NULL, WNOHANG, NULL);
    }
    return p;
}
